"""
Get API Key (https://developers.google.com/speed/docs/insights/v5/get-started)
Docs (https://developers.google.com/speed/docs/insights/v5/reference/pagespeedapi/runpagespeed)

Limits:
Queries per day = 25,000
Queries per 100 seconds = 400
The maximum width is 320px
"""

import base64
from pathlib import Path
from urllib import parse
from urllib.parse import urlparse

import requests


def get_screenshot(url):
    url_q = parse.quote_plus(url)
    image_path = str(urlparse(url).hostname).replace(Path(str(urlparse(url).hostname)).suffix, ".png")

    key = "AIzaSyBxH7Mf-4iqFrjs-5KL8P95hua5RDSOgapp"  # здесь ваш ключ
    strategy = "desktop"  # "mobile"
    u = f"https://www.googleapis.com/pagespeedonline/v5/runPagespeed?key={key}&strategy={strategy}&url={url_q}"

    try:
        j = requests.get(u).json()
        ss_encoded = j['lighthouseResult']['audits']['final-screenshot']['details']['data'].replace(
            "data:image/jpeg;base64,", "")
        ss_decoded = base64.b64decode(ss_encoded)
        with open(image_path, 'wb+') as f:
            f.write(ss_decoded)
    except Exception as ex:
        print(ex)
        exit(0)


get_screenshot('https://codeby.net')
